﻿--[[
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
]]--

YurrCombatLog = LibStub("AceAddon-3.0"):NewAddon("YurrCombatLog", "AceConsole-3.0", "AceEvent-3.0", "LibFuBarPlugin-Mod-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("YurrCombatLog")
local math_floor = _G.math.floor

local db = {
	["FuBar.AttachMinimap"] = YurrCombatLog:IsFuBarMinimapAttached()
}
--self.db.profile[info[#info]]
local defaults = {
    profile = {
		
		ChatFrame = 3,
		
		["minimapPosition"] = 205,
		
		filters = {
			hit = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
			heal = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
			miss = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
			cast = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
			gain = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
			drain = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
			leech = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
			dispel = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
			buff = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
			debuff = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
			fade = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
			interrupt = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
			death = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
			environment = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
			extra_attack = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
			enchant = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
			create = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
		},
			
		player = {
		["r"] = 0.50,
		["g"] = 0.50,
		["b"] = 1.00,
		},
		pet = {
		["r"] = 0.50,
		["g"] = 0.30,
		["b"] = 0.15,
		},
		raid = {
		["r"] = 1.00,
		["g"] = 0.44,
		["b"] = 0.20,
		},
		party = {
		["r"] = 0.65,
		["g"] = 1.00,
		["b"] = 0.65,
		},
		target = {
		["r"] = 1.00,
		["g"] = 0.46,
		["b"] = 1.00,
		},
--[[		targetoftarget {
		["r"] = 0.60,
		["g"] = 0.30,
		["b"] = 0.60,
		},]]--
		focus = {
		["r"] = 0.80,
		["g"] = 0.33,
		["b"] = 0.85,
		},
		other = {
		["r"] = 1.00,
		["g"] = 1.00,
		["b"] = 1.00,
		},
		physical = {
		["r"] = 1.00,
		["g"] = 1.00,
		["b"] = 1.00,
		},
		holy = {
		["r"] = 1.00,
		["g"] = 1.00,
		["b"] = 0.30,
		},
		fire = {
		["r"] = 1.00,
		["g"] = 0.15,
		["b"] = 0.18,
		},
		nature = {
		["r"] = 0.40,
		["g"] = 1.00,
		["b"] = 0.40,
		},
		frost = {
		["r"] = 0.30,
		["g"] = 0.30,
		["b"] = 0.90,
		},
		shadow = {
		["r"] = 1.00,
		["g"] = 0.70,
		["b"] = 1.00,
		},
		arcane = {
		["r"] = 0.75,
		["g"] = 0.75,
		["b"] = 0.75,
		},
		heal = {
		["r"] = 1.00,
		["g"] = 1.00,
		["b"] = 0.30,
		},
		miss = {
		["r"] = 1.00,
		["g"] = 0.5,
		["b"] = 0.5,
		},
		buff = {
		["r"] = 0.20,
		["g"] = 1.00,
		["b"] = 0.20,
		},
		debuff = {
		["r"] = 1.00,
		["g"] = 0.20,
		["b"] = 0.20,
		},
		skill = {
		["r"] = 1.00,
		["g"] = 1.00,
		["b"] = 0.4,
		},
		dirty = {
		["r"] = 0.93,
		["g"] = 0.65,
		["b"] = 0.37,
		}
		
    }
	
}

local options = {
type = "group",
name = "YurrCombatLog",
childGroups = "tree",
	args = {
		chatFrame = {
		type = "select",
		name = L["ChatFrame"],
		desc = "Select where you want your CombatLog output.",
		values = { "ChatFrame1", "ChatFrame2", "ChatFrame3", "ChatFrame4", "ChatFrame5", "ChatFrame6", "ChatFrame7" },
		get = function()
			return YurrCombatLog.db.profile.ChatFrame
		end,
		set = function(info, value)
			YurrCombatLog:ChatFrame(value)
			YurrCombatLog.db.profile.ChatFrame = value
		end,
		},
		YurrCombatLog = {
		type = "group",
		name = "YurrCombatLog",
		handler = YurrCombatLog,
			args = {
				filters = {
				type = "group",
				order = 1,
				name = L["Filters"],
					args = {
						any = {
						type = "group",
						name = L["*"],
						desc = L["Name Filters for *"],
						order = 1,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for *"],
								order = 1,
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										order = 1,
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										order = 2,
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 2,
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												},
											},
										},
									},
								},
							},
						},
						hit = {
						type = "group",
						name = L["Hit"],
						desc = L["Name Filters for Hit"],
						order = 2,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Hit"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						heal = {
						type = "group",
						name = L["Heal"],
						desc = L["Name Filters for Heal"],
						order = 3,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Heal"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						miss = {
						type = "group",
						name = L["Miss"],
						desc = L["Name Filters for Miss"],
						order = 4,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Miss"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						cast = {
						type = "group",
						name = L["Cast"],
						desc = L["Name Filters for Cast"],
						order = 5,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Cast"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						gain = {
						type = "group",
						name = L["Gain"],
						desc = L["Name Filters for Gain"],
						order = 6,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Gain"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						drain = {
						type = "group",
						name = L["Drain"],
						desc = L["Name Filters for Drain"],
						order = 7,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Drain"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						leech = {
						type = "group",
						name = L["Leech"],
						desc = L["Name Filters for Leech"],
						order = 8,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Leech"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						dispel = {
						type = "group",
						name = L["Dispel"],
						desc = L["Name Filters for Dispel"],
						order = 9,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Dispel"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						buff = {
						type = "group",
						name = L["Buff"],
						desc = L["Name Filters for Buff"],
						order = 10,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Buff"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						debuff = {
						type = "group",
						name = L["Debuff"],
						desc = L["Name Filters for Debuff"],
						order = 11,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Debuff"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						fade = {
						type = "group",
						name = L["Fade"],
						desc = L["Name Filters for Fade"],
						order = 12,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Fade"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						interrupt = {
						type = "group",
						name = L["Interrupt"],
						desc = L["Name Filters for Interrupt"],
						order = 13,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Interrupt"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						death = {
						type = "group",
						name = L["Death"],
						desc = L["Name Filters for Death"],
						order = 14,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Death"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						environment = {
						type = "group",
						name = L["Environment"],
						desc = L["Name Filters for Environment"],
						order = 15,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Environment"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						extra_attack = {
						type = "group",
						name = L["Extra Attack"],
						desc = L["Name Filters for Extra Attack"],
						order = 16,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Extra Attack"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						enchant = {
						type = "group",
						name = L["Enchant"],
						desc = L["Name Filters for Enchant"],
						order = 17,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Enchant"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						create = {
						type = "group",
						name = L["Create"],
						desc = L["Name Filters for Create"],
						order = 18,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Create"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
					},
				},
--[[				Events = {
				order = 2,
				},--]]
				Colors = {
				type = "group",
				name = L["Colors"],
				order = 3,
					args = {
						Affiliation = {
						type = "group",
						name = L["Affiliation"],
						inline = true,
							args = {
								player = {
								type = "color",
								name = L["Player"],
								set = "setColor",
								get = "getColor",
								order = 1,
								},
								pet = {
								type = "color",
								name = L["Pet"],
								set = "setColor",
								get = "getColor",
								order = 2,
								},
								raid = {
								type = "color",
								name = L["Raid"],
								set = "setColor",
								get = "getColor",
								order = 3,
								},
								party = {
								type = "color",
								name = L["Party"],
								set = "setColor",
								get = "getColor",
								order = 4,
								},
								target = {
								type = "color",
								name = L["Target"],
								set = "setColor",
								get = "getColor",
								order = 5,
								},
								--[[targettarget = {
								type = "color",
								name = L["Target of Target"],
								set = "setColor",
								get = "getColor",
								order = 6,
								},]]--
								focus = {
								type = "color",
								name = L["Focus"],
								set = "setColor",
								get = "getColor",
								order = 7,
								},
								other = {
								type = "color",
								name = L["Other"],
								set = "setColor",
								get = "getColor",
								order = 8,
								},
							}
						},
						School = {
						type = "group",
						name = L["School"],
						inline = true,
							args = {
								physical = {
								type = "color",
								name = L["Physical"],
								set = "setColor",
								get = "getColor",
								order = 1,
								},
								holy = {
								type = "color",
								name = L["Holy"],
								set = "setColor",
								get = "getColor",
								order = 2,
								},
								fire = {
								type = "color",
								name = L["Fire"],
								set = "setColor",
								get = "getColor",
								order = 3,
								},
								nature = {
								type = "color",
								name = L["Nature"],
								set = "setColor",
								get = "getColor",
								order = 4,
								},
								frost = {
								type = "color",
								name = L["Frost"],
								set = "setColor",
								get = "getColor",
								order = 5,
								},
								shadow = {
								type = "color",
								name = L["Shadow"],
								set = "setColor",
								get = "getColor",
								order = 6,
								},
								arcane = {
								type = "color",
								name = L["Arcane"],
								set = "setColor",
								get = "getColor",
								order = 7,
								},
							}
						},
						Type = {
						type = "group",
						name = L["Type"],
						inline = true,
							args = {
								heal = {
								type = "color",
								name = L["Heal"],
								set = "setColor",
								get = "getColor",
								order = 1,
								},
								miss = {
								type = "color",
								name = L["Miss"],
								set = "setColor",
								get = "getColor",
								order = 2,
								},
								buff = {
								type = "color",
								name = L["Buff"],
								set = "setColor",
								get = "getColor",
								order = 3,
								},
								debuff = {
								type = "color",
								name = L["Debuff"],
								set = "setColor",
								get = "getColor",
								order = 4,
								},
								skill = {
								type = "color",
								name = L["Skill"],
								set = "setColor",
								get = "getColor",
								order = 5,
								},
								--[[dirty = {
								type = "color",
								name = L["Dirty"],
								set = "setColor",
								get = "getColor",
								order = 6,
								},]]--
							}
						}
					}
				},
--[[				Format = {
			order = 4,
			},--]]
--[[				Watches = {
			order = 5,
			},--]]
				fubar = {	-- jacked from Omen
			type = "group",
			name = L["FuBar options"],
			desc = L["FuBar options"],
			order = -1,
			disabled = function() return YurrCombatLog.IsFuBarMinimapAttached == nil end,
				args = {
					attachMinimap = {
					type = "toggle",
					name = L["Attach to minimap"],
					desc = L["Attach to minimap"],
					get = function(info)
						return YurrCombatLog:IsFuBarMinimapAttached()
					end,
					set = function(info, v)
						YurrCombatLog:ToggleFuBarMinimapAttached()
						db["FuBar.AttachMinimap"] = YurrCombatLog:IsFuBarMinimapAttached()
					end
					},
					hideIcon = {
						type = "toggle",
						name = L["Hide minimap/FuBar icon"],
						desc = L["Hide minimap/FuBar icon"],
						get = function(info) 
							return db["FuBar.HideMinimapButton"] 
						end,
						set = function(info, v)
							db["FuBar.HideMinimapButton"] = v
							if v then
								YurrCombatLog:Hide()
							else
								YurrCombatLog:Show()
							end
						end
					},
					showIcon = {
					type = "toggle",
					name = L["Show icon"],
					desc = L["Show icon"],
					get = function(info) return YurrCombatLog:IsFuBarIconShown() end,
					set = function(info, v) YurrCombatLog:ToggleFuBarIconShown() end
					},
					showText = {
						type = "toggle",
						name = L["Show text"],
						desc = L["Show text"],
						get = function(info) return YurrCombatLog:IsFuBarTextShown() end,
						set = function(info, v) YurrCombatLog:ToggleFuBarTextShown() end
					},
					position = {
						type = "select",
						name = L["Position"],
						desc = L["Position"],
						values = {LEFT = L["Left"], CENTER = L["Center"], RIGHT = L["Right"]},
						get = function() 
							return YurrCombatLog:GetPanel() and YurrCombatLog:GetPanel():GetPluginSide(YurrCombatLog) 
						end,
						set = function(info, val)
							if YurrCombatLog:GetPanel() then
								YurrCombatLog:GetPanel():SetPluginSide(YurrCombatLog, val)
							end
						end
					}
				}
			}
			}
		}
	}
}

local FuBarOptions = {
	["configType"] = "AceConfigDialog-3.0",
	["defaultPosition"] = "RIGHT",
	["hideWithoutStandby"] = true,
	["independentProfile"] = true,
	["iconPath"] = "Interface\\Addons\\YurrCombatLog\\images\\Y.tga",
	["GameTooltip"] = true,
	["cannotDetachTooltip"] = true,
}

for type, val in pairs(FuBarOptions) do
	YurrCombatLog:SetFuBarOption(type, val)
end
FuBarOptions = nil

function YurrCombatLog:OnUpdateFuBarTooltip()
	local gtt = _G.GameTooltip
	local zones
	gtt:AddLine(L["YCL"])
	gtt:AddLine("|cffffff00"..L["Right-click|r to open the options menu"])
end

function YurrCombatLog:OnInitialize()
    -- Called when the addon is loaded
    self.db = LibStub("AceDB-3.0"):New("YurrCombatLogDB", defaults, "Default")
    LibStub("AceConfig-3.0"):RegisterOptionsTable("YurrCombatLog", options)
    self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("YurrCombatLog", "YurrCombatLog")
    self:RegisterChatCommand("ycl", "ChatCommand")
    self:RegisterChatCommand("yurrcombatlog", "ChatCommand")
	self:ChatFrame(self.db.profile.ChatFrame)
end

function YurrCombatLog:OnEnable()
    -- Called when the addon is enabled
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end

function YurrCombatLog:ChatFrame(frame)
	if frame == 1 then
		outputFrame = ChatFrame1
	elseif frame == 2 then
		outputFrame = ChatFrame2
	elseif frame == 3 then
		outputFrame = ChatFrame3
	elseif frame == 4 then
		outputFrame = ChatFrame4
	elseif frame == 5 then
		outputFrame = ChatFrame5
	elseif frame == 6 then
		outputFrame = ChatFrame6
	elseif frame == 7 then
		outputFrame = ChatFrame7
	end
end

function YurrCombatLog:ChatCommand(input)
    if not input or input:trim() == "" then
        LibStub("AceConfigDialog-3.0"):Open("YurrCombatLog")
    else
        LibStub("AceConfigCmd-3.0").HandleCommand(YurrCombatLog, "ycl", "YurrCombatLog", input)
    end
end

--credits to Kernelerror from my HappyFunRock
function YurrCombatLog:isChecked(eventType, sourceGUID, destGUID, sourceFlags, destFlags)

	--Player
	if (self.db.profile.filters[eventType].source.Player == true and sourceGUID == UnitGUID("Player"))  then
		return true;
	elseif (self.db.profile.filters[eventType].victim.Player == true and destGUID == UnitGUID("Player")) then
		return true;
	--Pet
	elseif (self.db.profile.filters[eventType].source.Pet == true and CombatLog_Object_IsA(sourceFlags, isPet)) then
		return true;
	elseif (self.db.profile.filters[eventType].victim.Pet == true and CombatLog_Object_IsA(destGUID, isPet)) then
		return true;
	--Party
	elseif (self.db.profile.filters[eventType].source.Party == true and CombatLog_Object_IsA(sourceFlags, isParty))  then
		return true;
	elseif (self.db.profile.filters[eventType].victim.Party == true and destGUID == CombatLog_Object_IsA(destGUID, isParty)) then
		return true;
	--Raid
	elseif (self.db.profile.filters[eventType].source.Raid == true and CombatLog_Object_IsA(sourceFlags, isRaid))  then
		return true;
	elseif (self.db.profile.filters[eventType].victim.Raid == true and CombatLog_Object_IsA(destGUID, isRaid)) then
		return true;
	--Target
	elseif (self.db.profile.filters[eventType].source.Target == true and CombatLog_Object_IsA(sourceGUID, isTarget)) then
		return true;
	elseif (self.db.profile.filters[eventType].victim.Target == true and CombatLog_Object_IsA(destGUID, isTarget)) then
		return true;
	--Focus
	elseif (self.db.profile.filters[eventType].source.Focus == true and CombatLog_Object_IsA(sourceFlags, isFocus))  then
		return true;
	elseif (self.db.profile.filters[eventType].victim.Focus == true and CombatLog_Object_IsA(destGUID, isFocus)) then
		return true;
	--Other
	elseif (self.db.profile.filters[eventType].source.Other == true and CombatLog_Object_IsA(sourceFlags, isOther))  then
		return true;
	elseif (self.db.profile.filters[eventType].victim.Other == true and CombatLog_Object_IsA(destGUID, isOther)) then
		return true;
	end
	
	--if it doesnt confirm to any IF statement
	return false;
	
end

--	Converts 4 floats into FF code
function YurrCombatLog:CombatLog_Color_FloatToText(r,g,b,a)
	if ( type(r) == "table" ) then
		r, g, b, a = r.r, r.g, r.b, r.a;
	end
	a = min(1, a or 1) * 255
	r = min(1, r) * 255
	g = min(1, g) * 255
	b = min(1, b) * 255
	
	-- local fmt = "%.2x";
	return ("%.2x%.2x%.2x%.2x"):format(math_floor(a), math_floor(r), math_floor(g), math_floor(b))
end

function YurrCombatLog:UnitColoring(sName, sFlags, dName, dFlags)

	if CombatLog_Object_IsA(sFlags, isPlayer) then
		self.player = self:CombatLog_Color_FloatToText(self.db.profile.player.r, self.db.profile.player.g, self.db.profile.player.b)
		self.sourceNameColored = "|c"..self.player..sName.."|r"
		
	elseif CombatLog_Object_IsA(sFlags, isPet) then
		self.pet = self:CombatLog_Color_FloatToText(self.db.profile.pet.r, self.db.profile.pet.g, self.db.profile.pet.b)
		self.sourceNameColored = "|c"..self.pet..sName.."|r"
		
		elseif CombatLog_Object_IsA(sFlags, isParty) then
		self.party = self:CombatLog_Color_FloatToText(self.db.profile.party.r, self.db.profile.party.g, self.db.profile.party.b)
		self.sourceNameColored = "|c"..self.party..sName.."|r"
		
	elseif CombatLog_Object_IsA(sFlags, isRaid) then
		self.raid = self:CombatLog_Color_FloatToText(self.db.profile.raid.r, self.db.profile.raid.g, self.db.profile.raid.b)
		self.sourceNameColored = "|c"..self.raid..sName.."|r"
		
	--[[elseif CombatLog_Object_IsA(sFlags, isTarget) then
		target = self:CombatLog_Color_FloatToText(self.db.profile.target.r, self.db.profile.target.g, self.db.profile.target.b)
		self.sourceNameColored = "|c"..target..sName.."|r"]]--
		
	elseif CombatLog_Object_IsA(sFlags, isTarget) then
		self.target = self:CombatLog_Color_FloatToText(self.db.profile.target.r, self.db.profile.target.g, self.db.profile.target.b)
		self.sourceNameColored = "|c"..self.target..sName.."|r"
		
	elseif CombatLog_Object_IsA(sFlags, isOther) then
		self.other = self:CombatLog_Color_FloatToText(self.db.profile.other.r, self.db.profile.other.g, self.db.profile.other.b)
		self.sourceNameColored = "|c"..self.other..sName.."|r"
	
	elseif CombatLog_Object_IsA(sFlags, isFocus) then
		self.focus = self:CombatLog_Color_FloatToText(self.db.profile.focus.r, self.db.profile.focus.g, self.db.profile.focus.b)
		self.sourceNameColored = "|c"..self.focus..sName.."|r"
	end


	if CombatLog_Object_IsA(dFlags, isPlayer) then
		self.player = self:CombatLog_Color_FloatToText(self.db.profile.player.r, self.db.profile.player.g, self.db.profile.player.b)
		self.destNameColored = "|c"..self.player..dName.."|r"
		
	elseif CombatLog_Object_IsA(dFlags, isPet) then
		self.pet = self:CombatLog_Color_FloatToText(self.db.profile.pet.r, self.db.profile.pet.g, self.db.profile.pet.b)
		self.destNameColored = "|c"..self.pet..dName.."|r"
		
	elseif CombatLog_Object_IsA(dFlags, isParty) then
		self.party = self:CombatLog_Color_FloatToText(self.db.profile.party.r, self.db.profile.party.g, self.db.profile.party.b)
		self.destNameColored = "|c"..self.party..dName.."|r"
		
	elseif CombatLog_Object_IsA(dFlags, isRaid) then
		self.raid = self:CombatLog_Color_FloatToText(self.db.profile.raid.r, self.db.profile.raid.g, self.db.profile.raid.b)
		self.destNameColored = "|c"..self.raid..dName.."|r"
	
	--[[elseif CombatLog_Object_IsA(dFlags, isTarget) then
		target = self:CombatLog_Color_FloatToText(self.db.profile.target.r, self.db.profile.target.g, self.db.profile.target.b)
		self.destNameColored = "|c"..target..dName.."|r"]]--
		
	elseif CombatLog_Object_IsA(dFlags, isTarget) then
		self.target = self:CombatLog_Color_FloatToText(self.db.profile.target.r, self.db.profile.target.g, self.db.profile.target.b)
		self.destNameColored = "|c"..self.target..dName.."|r"
		
	elseif CombatLog_Object_IsA(dFlags, isOther) then
		self.other = self:CombatLog_Color_FloatToText(self.db.profile.other.r, self.db.profile.other.g, self.db.profile.other.b)
		self.destNameColored = "|c"..self.other..dName.."|r"
		
	elseif CombatLog_Object_IsA(dFlags, isFocus) then
		self.focus = self:CombatLog_Color_FloatToText(self.db.profile.focus.r, self.db.profile.focus.g, self.db.profile.focus.b)
		self.destNameColored = "|c"..self.focus..dName.."|r"
	end
	
end

function YurrCombatLog:SwingMissType(type)

	if type == "ABSORB" then
		self.missed = "absorb"
	elseif type == "BLOCK" then
		self.missed = "block"
	elseif type == "DEFLECT" then
		self.missed = "deflect"
	elseif type == "DODGE" then
		self.missed = "dodge"
	elseif type == "EVADE" then
		self.missed = "evade"
	elseif type == "IMMUNE" then
		self.missed = "immune"
	elseif type == "MISS" then
		self.missed = "miss"
	elseif type == "PARRY" then
		self.missed = "parry"
	elseif type == "REFLECT" then
		self.missed = "reflect"
	elseif type == "RESIST" then
		self.missed = "resist"
	end
	
end

function YurrCombatLog:SpellSchool(school, spellName)

	if spellName == nil then 
		spellName = "Melee"
	end
	
	if school == 1 then
		physical = self:CombatLog_Color_FloatToText(self.db.profile.physical.r, self.db.profile.physical.g, self.db.profile.physical.b)
		self.spellschool = "|c"..physical..spellName.."|r" --physical
	elseif school == 2 then
		holy = self:CombatLog_Color_FloatToText(self.db.profile.holy.r, self.db.profile.holy.g, self.db.profile.holy.b)
		self.spellschool = "|c"..holy..spellName.."|r" --holy
	elseif school == 4 then
		fire = self:CombatLog_Color_FloatToText(self.db.profile.fire.r, self.db.profile.fire.g, self.db.profile.fire.b)
		self.spellschool = "|c"..fire..spellName.."|r" --fire
	elseif school == 8 then
		nature = self:CombatLog_Color_FloatToText(self.db.profile.nature.r, self.db.profile.nature.g, self.db.profile.nature.b)
		self.spellschool = "|c"..nature..spellName.."|r" --nature
	elseif school == 16 then
		frost = self:CombatLog_Color_FloatToText(self.db.profile.frost.r, self.db.profile.frost.g, self.db.profile.frost.b)
		self.spellschool = "|c"..frost..spellName.."|r" --frost
	elseif school == 32 then
		shadow = self:CombatLog_Color_FloatToText(self.db.profile.shadow.r, self.db.profile.shadow.g, self.db.profile.shadow.b)
		self.spellschool = "|c"..shadow..spellName.."|r" --shadow
	elseif school == 64 then
		arcane = self:CombatLog_Color_FloatToText(self.db.profile.arcane.r, self.db.profile.arcane.g, self.db.profile.arcane.b)
		self.spellschool = "|c"..arcane..spellName.."|r" --arcane 
	end

end

function YurrCombatLog:BuffColoring(aType, spName, eventType)

	if eventType == "SPELL_AURA_APPLIED" then
		if aType == "BUFF" or aType == nil then
		buff = self:CombatLog_Color_FloatToText(self.db.profile.buff.r, self.db.profile.buff.g, self.db.profile.buff.b)
		self.spellNameColored = "|c"..buff.." ++ "..spName.."|r"
		elseif aType == "DEBUFF" then
		debuff = self:CombatLog_Color_FloatToText(self.db.profile.debuff.r, self.db.profile.debuff.g, self.db.profile.debuff.b)
		self.spellNameColored = "|c"..debuff.." ++ "..spName.."|r"
		end
	elseif eventType == "SPELL_AURA_REMOVED" then
		if aType == "BUFF" or aType == nil then
		buff = self:CombatLog_Color_FloatToText(self.db.profile.skill.r, self.db.profile.skill.g, self.db.profile.skill.b)
		self.spellNameColored = "|c"..buff.." -- "..spName.."|r"
		elseif aType == "DEBUFF" then
		debuff = self:CombatLog_Color_FloatToText(self.db.profile.skill.r, self.db.profile.skill.g, self.db.profile.skill.b)
		self.spellNameColored = "|c"..debuff.." -- "..spName.."|r"
		end
	end
end

function YurrCombatLog:EnchantColoring(enchantName, eventType)

	if eventType == "ENCHANT_APPLIED" then
		enchant = self:CombatLog_Color_FloatToText(self.db.profile.skill.r, self.db.profile.skill.g, self.db.profile.skill.b)
		self.enchantNameColored = "|c"..enchant..enchantName.."|r"
	elseif eventType == "ENCHANT_REMOVED" then
		enchant = self:CombatLog_Color_FloatToText(self.db.profile.skill.r, self.db.profile.skill.g, self.db.profile.skill.b)
		self.enchantNameColored = "|c"..enchant..enchantName.."|r"
	end
	
end

function YurrCombatLog:DamageColoring(dmgSchool, dmgAmount)
	
	if dmgSchool == 1 then
		physical = self:CombatLog_Color_FloatToText(self.db.profile.physical.r, self.db.profile.physical.g, self.db.profile.physical.b)
		self.amountColored = "|c"..physical..dmgAmount.."|r" --physical
	elseif dmgSchool == 2 then
		holy = self:CombatLog_Color_FloatToText(self.db.profile.holy.r, self.db.profile.holy.g, self.db.profile.holy.b)
		self.amountColored = "|c"..holy..dmgAmount.."|r" --holy
	elseif dmgSchool == 4 then
		fire = self:CombatLog_Color_FloatToText(self.db.profile.fire.r, self.db.profile.fire.g, self.db.profile.fire.b)
		self.amountColored = "|c"..fire..dmgAmount.."|r" --fire
	elseif dmgSchool == 8 then
		nature = self:CombatLog_Color_FloatToText(self.db.profile.nature.r, self.db.profile.nature.g, self.db.profile.nature.b)
		self.amountColored = "|c"..nature..dmgAmount.."|r" --nature
	elseif dmgSchool == 16 then
		frost = self:CombatLog_Color_FloatToText(self.db.profile.frost.r, self.db.profile.frost.g, self.db.profile.frost.b)
		self.amountColored = "|c"..frost..dmgAmount.."|r" --frost
	elseif dmgSchool == 32 then
		shadow = self:CombatLog_Color_FloatToText(self.db.profile.shadow.r, self.db.profile.shadow.g, self.db.profile.shadow.b)
		self.amountColored = "|c"..shadow..dmgAmount.."|r" --shadow
	elseif dmgSchool == 64 then
		arcane = self:CombatLog_Color_FloatToText(self.db.profile.arcane.r, self.db.profile.arcane.g, self.db.profile.arcane.b)
		self.amountColored = "|c"..arcane..dmgAmount.."|r" --arcane 
	elseif dmgSchool == "SPELL_EXTRA_ATTACKS" then
		skill = self:CombatLog_Color_FloatToText(self.db.profile.skill.r, self.db.profile.skill.g, self.db.profile.skill.b)
		self.amountColored = "|c"..skill..dmgAmount.."|r" --skill 
	end
	
end

function YurrCombatLog:EnvironmentalDamageType(envDmgType)

	if envDmgType == "DROWNING" then
		self.environmentalType = "drown"
	elseif envDmgType == "FALLING" then
		self.environmentalType = "fall"
	elseif envDmgType == "FATIGUE" then
		self.environmentalType = "fatigue"
	elseif envDmgType == "FIRE" then
		self.environmentalType = "fire"
	elseif envDmgType == "LAVA" then
		self.environmentalType = "lava"
	elseif envDmgType == "SLIME" then
		self.environmentalType = "slime"
	end
	
end

function YurrCombatLog:COMBAT_LOG_EVENT_UNFILTERED(arg1, timestamp, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)
	--[[
	-- Spell standard order
	local spellId, spellName, spellSchool;
	local extraSpellId, extraSpellName, extraSpellSchool;

	-- For Melee/Ranged swings and enchants
	local nameIsNotSpell, extraNameIsNotSpell; 

	-- Damage standard order
	local amount, school, resisted, blocked, absorbed, critical, glancing, crushing;
	-- Miss argument order
	local missType;
	-- Aura arguments
	local auraType; -- BUFF or DEBUFF

	-- Enchant arguments
	local itemId, itemName;

	-- Special Spell values
	local valueType = 1;  -- 1 = School, 2 = Power Type
	local extraAmount; -- Used for Drains and Leeches
	local powerType; -- Used for energizes, drains and leeches
	local environmentalType; -- Used for environmental damage
	local message; -- Used for server spell messages
	local originalEvent = event; -- Used for spell links
	]]--
	
	if sourceName == UnitName("Player") then
		sourceName = "You"
	end
	if destName == UnitName("Player") then
		destName = "You"
	end
	
	--if sourceGUID == UnitGUID("Player") or destGUID == UnitGUID("Player") then
	
		
		if event == "SWING_DAMAGE" then eventType = "hit" if( self:isChecked(eventType, sourceGUID, destGUID, sourceFlags, destFlags) == true ) then
			amount, school, resisted, blocked, absorbed, critical, glancing, crushing = ...
			self:UnitColoring(sourceName, sourceFlags, destName, destFlags)
			self:SpellSchool(school)
			self:DamageColoring(school, amount)
			if critical == 1 then critical = "Crit " self.amountColored = "*"..self.amountColored.."*" else critical = "" end
			outputFrame:AddMessage("["..self.sourceNameColored.."] "..self.spellschool.." "..critical.."["..self.destNameColored.."] "..self.amountColored)
			end
			
		elseif event == "SWING_MISSED" then eventType = "miss" if( self:isChecked(eventType, sourceGUID, destGUID, sourceFlags, destFlags) == true ) then
			missType = ...
			self:UnitColoring(sourceName, sourceFlags, destName, destFlags)
			self:SwingMissType(missType)
			if self.missed == "miss" then
				outputFrame:AddMessage("["..self.sourceNameColored.."] "..self.missed.." ["..self.destNameColored.."] ")
			else
				outputFrame:AddMessage("["..self.destNameColored.."] "..self.missed.." ["..self.sourceNameColored.."] ")
			end
			end
			
		elseif event == "RANGE_DAMAGE" then eventType = "hit" if( self:isChecked(eventType, sourceGUID, destGUID, sourceFlags, destFlags) == true ) then
			spellId, spellName, spellSchool, amount, school, resisted, blocked, absorbed, critical, glancing, crushing = ...
			self:UnitColoring(sourceName, sourceFlags, destName, destFlags)
			self:DamageColoring(spellSchool, amount)
			if critical == 1 then critical = "Crit " self.amountColored = "*"..self.amountColored.."*" else critical = "" end
			outputFrame:AddMessage("["..self.sourceNameColored.."] "..spellName..critical.."["..self.destNameColored.."] "..self.amountColored)
			end
			
		elseif event == "RANGE_MISSED" then eventType = "miss" if( self:isChecked(eventType, sourceGUID, destGUID, sourceFlags, destFlags) == true ) then
			spellId, spellName, spellSchool, missType = ...
			self:UnitColoring(sourceName, sourceFlags, destName, destFlags)
			self:SwingMissType(missType)
			if self.missed == "miss" then
				outputFrame:AddMessage("["..self.sourceNameColored.."] "..spellName.." "..self.missed.." ["..self.destNameColored.."]")
			else
				outputFrame:AddMessage("["..self.sourceNameColored.."] "..spellName.." ["..self.destNameColored.."] "..self.missed)
			end
			end
			
		elseif event == "SPELL_DAMAGE" then eventType = "cast" if( self:isChecked(eventType, sourceGUID, destGUID, sourceFlags, destFlags) == true ) then
			spellId, spellName, spellSchool, amount, school, resisted, blocked, absorbed, critical, glancing, crushing = ...
			self:UnitColoring(sourceName, sourceFlags, destName, destFlags)
			self:SpellSchool(spellSchool, spellName)
			self:DamageColoring(spellSchool, amount)
			if critical == 1 then critical = "Crit " self.amountColored = "*"..self.amountColored.."*" else critical = "" end
			outputFrame:AddMessage("["..self.sourceNameColored.."] "..self.spellschool.." "..critical.."["..self.destNameColored.."] "..self.amountColored)
			end
			
		elseif event == "SPELL_MISSED" then eventType = "miss" if( self:isChecked(eventType, sourceGUID, destGUID, sourceFlags, destFlags) == true ) then
			spellId, spellName, spellSchool, missType = ...
			self:UnitColoring(sourceName, sourceFlags, destName, destFlags)
			self:SpellSchool(spellSchool, spellName)
			self:SwingMissType(missType)
			if self.missed == " miss " then
				outputFrame:AddMessage("["..self.sourceNameColored.."] "..self.spellschool..self.missed.." ["..self.destNameColored.."]")
			else
				outputFrame:AddMessage("["..self.sourceNameColored.."] "..self.spellschool.." ["..self.destNameColored.."] "..self.missed)
			end
			end
			
		elseif event == "SPELL_HEAL" then eventType = "heal" if( self:isChecked(eventType, sourceGUID, destGUID, sourceFlags, destFlags) == true ) then
			spellId, spellName, spellSchool, amount, critical = ...
			self:UnitColoring(sourceName, sourceFlags, destName, destFlags)
			self:SpellSchool(spellSchool, spellName)
			self:DamageColoring(spellSchool, amount)
			if critical == 1 then critical = "Crit " self.amountColored = "*"..self.amountColored.."*" else critical = "" end
			outputFrame:AddMessage("["..self.sourceNameColored.."] "..self.spellschool.." "..critical.."["..self.destNameColored.."] "..self.amountColored)
			end
			
		elseif event == "SPELL_ENERGIZE" then eventType = "gain" if( self:isChecked(eventType, sourceGUID, destGUID, sourceFlags, destFlags) == true ) then
			spellId, spellName, spellSchool, amount, powerType = ...
			self:UnitColoring(sourceName, sourceFlags, destName, destFlags)
			self:SpellSchool(spellSchool, spellName)
			self:DamageColoring(spellSchool, amount)
			if critical == 1 then critical = "Crit " self.amountColored = "*"..self.amountColored.."*" else critical = "" end
			outputFrame:AddMessage("["..self.sourceNameColored.."] "..self.spellschool.." "..critical.."Energize ["..self.destNameColored.."] "..self.amountColored)
			end
			
		elseif event == "SPELL_PERIODIC_MISSED" then
			spellId, spellName, spellSchool, missType = ...
			
		elseif event == "SPELL_PERIODIC_DAMAGE" then eventType = "cast" if( self:isChecked(eventType, sourceGUID, destGUID, sourceFlags, destFlags) == true ) then
			spellId, spellName, spellSchool, amount, school, resisted, blocked, absorbed, critical, glancing, crushing = ...
			self:UnitColoring(sourceName, sourceFlags, destName, destFlags)
			self:SpellSchool(spellSchool, spellName)
			self:DamageColoring(spellSchool, amount)
			if critical == 1 then critical = "Crit " self.amountColored = "*"..self.amountColored.."*" else critical = "" end
			outputFrame:AddMessage("["..self.sourceNameColored.."] "..self.spellschool.." "..critical.."Dot ["..self.destNameColored.."] ~"..self.amountColored.."~")
			end
			
		elseif event == "SPELL_PERIODIC_HEAL" then eventType = "heal" if( self:isChecked(eventType, sourceGUID, destGUID, sourceFlags, destFlags) == true ) then
			spellId, spellName, spellSchool, amount, critical = ...
			self:UnitColoring(sourceName, sourceFlags, destName, destFlags)
			self:SpellSchool(spellSchool, spellName)
			self:DamageColoring(spellSchool, amount)
			if critical == 1 then critical = "Crit " self.amountColored = "*"..self.amountColored.."*" else critical = "" end
			outputFrame:AddMessage("["..self.sourceNameColored.."] "..self.spellschool.." "..critical.."regen ["..self.destNameColored.."] ~"..self.amountColored.."~")
			end
			
		elseif event == "SPELL_PERIODIC_DRAIN" then eventType = "drain" if( self:isChecked(eventType, sourceGUID, destGUID, sourceFlags, destFlags) == true ) then
			spellId, spellName, spellSchool, amount, powerType, extraAmount = ...
			self:UnitColoring(sourceName, sourceFlags, destName, destFlags)
			self:SpellSchool(spellSchool, spellName)
			self:DamageColoring(spellSchool, amount)
			if critical == 1 then critical = "Crit " self.amountColored = "*"..self.amountColored.."*" else critical = "" end
			outputFrame:AddMessage("["..self.sourceNameColored.."] "..self.spellschool.." "..critical.."Drain ["..self.destNameColored.."] ~"..self.amountColored.."~")
			end
			
		elseif event == "SPELL_PERIODIC_LEECH" then eventType = "leech" if( self:isChecked(eventType, sourceGUID, destGUID, sourceFlags, destFlags) == true ) then
			spellId, spellName, spellSchool, amount, powerType, extraAmount = ...
			self:UnitColoring(sourceName, sourceFlags, destName, destFlags)
			self:SpellSchool(spellSchool, spellName)
			self:DamageColoring(spellSchool, amount)
			if critical == 1 then critical = "Crit " self.amountColored = "*"..self.amountColored.."*" else critical = "" end
			outputFrame:AddMessage("["..self.sourceNameColored.."] "..self.spellschool.." "..critical.."Leech ["..self.destNameColored.."] ~"..self.amountColored.."~")
			end
			
		elseif event == "SPELL_PERIODIC_ENERGIZE" then eventType = "gain" if( self:isChecked(eventType, sourceGUID, destGUID, sourceFlags, destFlags) == true ) then
			spellId, spellName, spellSchool, amount, powerType = ...
			self:UnitColoring(sourceName, sourceFlags, destName, destFlags)
			self:SpellSchool(spellSchool, spellName)
			self:DamageColoring(spellSchool, amount)
			if critical == 1 then critical = "Crit " self.amountColored = "*"..self.amountColored.."*" else critical = "" end
			outputFrame:AddMessage("["..self.sourceNameColored.."] "..self.spellschool.." "..powerType.."["..self.destNameColored.."] "..self.amountColored)
			end
			
		elseif event == "SPELL_DRAIN" then eventType = "drain" if( self:isChecked(eventType, sourceGUID, destGUID, sourceFlags, destFlags) == true ) then
			spellId, spellName, spellSchool, amount, powerType, extraAmount = ...
			self:UnitColoring(sourceName, sourceFlags, destName, destFlags)
			self:SpellSchool(spellSchool, spellName)
			self:DamageColoring(spellSchool, amount)
			if critical == 1 then critical = "Crit " self.amountColored = "*"..self.amountColored.."*" else critical = "" end
			outputFrame:AddMessage("["..self.sourceNameColored.."] "..self.spellschool.." "..critical.."Drain ["..self.destNameColored.."] "..self.amountColored)
			end
			
		elseif event == "SPELL_LEECH" then eventType = "leech" if( self:isChecked(eventType, sourceGUID, destGUID, sourceFlags, destFlags) == true ) then
			spellId, spellName, spellSchool, amount, powerType, extraAmount = ...
			self:UnitColoring(sourceName, sourceFlags, destName, destFlags)
			self:SpellSchool(spellSchool, spellName)
			self:DamageColoring(spellSchool, amount)
			if critical == 1 then critical = "Crit " self.amountColored = "*"..self.amountColored.."*" else critical = "" end
			outputFrame:AddMessage("["..self.sourceNameColored.."] "..self.spellschool.." "..critical.."Leech ["..self.destNameColored.."] "..self.amountColored)
			end
			
		elseif event == "SPELL_INTERRUPT" then eventType = "interrupt" if( self:isChecked(eventType, sourceGUID, destGUID, sourceFlags, destFlags) == true ) then
			spellId, spellName, spellSchool, extraSpellId, extraSpellName, extraSpellSchool = ...
			self:UnitColoring(sourceName, sourceFlags, destName, destFlags)
			self:SpellSchool(extraSpellSchool, extraSpellName)
			outputFrame:AddMessage("["..self.sourceNameColored.."] interrupt ["..self.destNameColored.."] "..self.spellschool)
			end
			
		elseif event == "SPELL_EXTRA_ATTACKS" then eventType = "extra_attack" if( self:isChecked(eventType, sourceGUID, destGUID, sourceFlags, destFlags) == true ) then
			spellId, spellName, spellSchool, amount = ...
			self:UnitColoring(sourceName, sourceFlags, destName, destFlags)
			self:DamageColoring(event, spellName)
			outputFrame:AddMessage("["..self.sourceNameColored.."] ".."+ 1 attacks ("..self.amountColored..")")
			end
			
		elseif event == "SPELL_INSTAKILL" then
			spellId, spellName, spellSchool = ...

		elseif event == "SPELL_DURABILITY_DAMAGE" then
			spellId, spellName, spellSchool = ...

		elseif event == "SPELL_DURABILITY_DAMAGE_ALL" then
			spellId, spellName, spellSchool = ...

		elseif event == "SPELL_DISPEL_FAILED" then
			spellId, spellName, spellSchool, extraSpellId, extraSpellName, extraSpellSchool = ...

		elseif event == "SPELL_AURA_DISPELLED" then
			spellId, spellName, spellSchool, extraSpellId, extraSpellName, extraSpellSchool, auraType = ...

		elseif event == "SPELL_AURA_STOLEN" then
			spellId, spellName, spellSchool, extraSpellId, extraSpellName, extraSpellSchool, auraType = ...
			
		elseif event == "SPELL_AURA_APPLIED" then eventType = "buff" if( self:isChecked(eventType, sourceGUID, destGUID, sourceFlags, destFlags) == true ) then
			spellId, spellName, spellSchool, auraType = ...
			--(source arguments are nil)
			sourceName, sourceGUID, sourceFlags = destName, destGUID, destFlags
			self:UnitColoring(sourceName, sourceFlags, destName, destFlags)
			self:BuffColoring(auraType, spellName, event)
			outputFrame:AddMessage("["..self.sourceNameColored.."]"..self.spellNameColored)
			end
			
		elseif event == "SPELL_AURA_REMOVED" then eventType = "buff" if( self:isChecked(eventType, sourceGUID, destGUID, sourceFlags, destFlags) == true ) then
			spellId, spellName, spellSchool, auraType = ...
			--(source arguments are nil)
			sourceName, sourceGUID, sourceFlags = destName, destGUID, destFlags
			self:UnitColoring(sourceName, sourceFlags, destName, destFlags)
			self:BuffColoring(auraType, spellName, event)
			outputFrame:AddMessage("["..self.sourceNameColored.."]"..self.spellNameColored)
			end

		elseif event == "SPELL_AURA_APPLIED_DOSE" then
			spellId, spellName, spellSchool, auraType, amount = ...
			--(source arguments are nil)

		elseif event == "SPELL_AURA_REMOVED_DOSE" then
			spellId, spellName, spellSchool, auraType, amount = ...
			--(source arguments are nil)

		elseif event == "SPELL_CAST_START" then
			spellId, spellName, spellSchool = ...

		elseif event == "SPELL_CAST_SUCCESS" then
			spellId, spellName, spellSchool = ...

		elseif event == "SPELL_CAST_FAILED" then
			spellId, spellName, spellSchool, missType = ...
			
			--Special Events
		elseif event == "DAMAGE_SHIELD" then eventType = "cast" if( self:isChecked(eventType, sourceGUID, destGUID, sourceFlags, destFlags) == true ) then
			spellId, spellName, spellSchool, amount, school, resisted, blocked, absorbed, critical, glancing, crushing = ...
			self:UnitColoring(sourceName, sourceFlags, destName, destFlags)
			self:SpellSchool(spellSchool, spellName)
			self:DamageColoring(spellSchool, amount)
			if critical == 1 then critical = "Crit " self.amountColored = "*"..self.amountColored.."*" else critical = "" end
			outputFrame:AddMessage("["..self.sourceNameColored.."] "..self.spellschool.." "..critical.."["..self.destNameColored.."] "..self.amountColored)
			end
			
		elseif event == "DAMAGE_SPLIT" then
			spellId, spellName, spellSchool, amount, school, resisted, blocked, absorbed, critical, glancing, crushing = ...;
			
		elseif event == "DAMAGE_SHIELD_MISSED" then eventType = "miss" if( self:isChecked(eventType, sourceGUID, destGUID, sourceFlags, destFlags) == true ) then
			spellId, spellName, spellSchool, missType = ...
			self:UnitColoring(sourceName, sourceFlags, destName, destFlags)
			self:SpellSchool(spellSchool, spellName)
			self:SwingMissType(missType)
			outputFrame:AddMessage("["..self.sourceNameColored.."] "..self.spellschool.." ["..self.destNameColored.."] "..self.missed)
			end
			
		elseif event == "ENCHANT_APPLIED" then eventType = "enchant" if( self:isChecked(eventType, sourceGUID, destGUID, sourceFlags, destFlags) == true ) then
			spellName, itemID, itemName = ...
			sourceName, sourceGUID, sourceFlags = destName, destGUID, destFlags
			self:UnitColoring(sourceName, sourceFlags, destName, destFlags)
			self:EnchantColoring(spellName, event)
			outputFrame:AddMessage("Enchant: ["..self.sourceNameColored.."] "..self.enchantNameColored.." to ["..self.destNameColored.."] "..itemName)
			end
			
		elseif event == "ENCHANT_REMOVED" then eventType = "enchant" if( self:isChecked(eventType, sourceGUID, destGUID, sourceFlags, destFlags) == true ) then
			spellName, itemID, itemName = ...
			sourceName, sourceGUID, sourceFlags = destName, destGUID, destFlags
			self:UnitColoring(sourceName, sourceFlags, destName, destFlags)
			self:EnchantColoring(spellName, event)
			outputFrame:AddMessage("["..self.destNameColored.."] "..self.enchantNameColored.." "..itemName)
			end
		
		elseif event == "PARTY_KILL" then
			self:UnitColoring(sourceName, sourceFlags, destName, destFlags)
			outputFrame:AddMessage("["..self.sourceNameColored.."] killed ["..self.destNameColored.."]")
			
		elseif event == "UNIT_DESTROYED" then
			self:UnitColoring(sourceName, sourceFlags, destName, destFlags)
			outputFrame:AddMessage("Death: ["..self.destNameColored.."]")
			
		elseif event == "UNIT_DIED" then
			self:UnitColoring(sourceName, sourceFlags, destName, destFlags)
			outputFrame:AddMessage("Death: ["..self.destNameColored.."]")
			
		elseif event == "ENVIRONMENTAL_DAMAGE" then eventType = "environment" if( self:isChecked(eventType, sourceGUID, destGUID, sourceFlags, destFlags) == true ) then
			environmentalType, amount, school, resisted, blocked, absorbed, critical, glancing, crushing = ...
			self:UnitColoring(sourceName, sourceFlags, destName, destFlags)
			self:EnvironmentalDamageType(environmentalType)
			self:SpellSchool(school, spellName)
			self:DamageColoring(school, amount)
			outputFrame:AddMessage("["..self.destNameColored.."] "..self.environmentalType.." "..self.amountColored)
			end
		end
	--end
end

function YurrCombatLog:getColor(info)
	return self.db.profile[info[#info]].r, self.db.profile[info[#info]].g, self.db.profile[info[#info]].b
end
function YurrCombatLog:setColor(info, r, g, b)
	self.db.profile[info[#info]] = { ["r"]=r, ["g"]=g, ["b"]=b }
end

function YurrCombatLog:getFilter(info)
	return self.db.profile[info[#info-4]][info[#info-3]][info[#info-1]][info[#info]]
end
function YurrCombatLog:setFilter(info, value)
	self.db.profile[info[#info-4]][info[#info-3]][info[#info-1]][info[#info]] = value
end



isPlayer = bit.bor(
	COMBATLOG_OBJECT_AFFILIATION_MINE,
	COMBATLOG_OBJECT_REACTION_FRIENDLY,
	COMBATLOG_OBJECT_CONTROL_PLAYER,
	COMBATLOG_OBJECT_TYPE_PLAYER)
isPet = bit.bor(
	COMBATLOG_OBJECT_AFFILIATION_MINE,
	COMBATLOG_OBJECT_AFFILIATION_PARTY,
	COMBATLOG_OBJECT_AFFILIATION_RAID,
	COMBATLOG_OBJECT_AFFILIATION_OUTSIDER,
	COMBATLOG_OBJECT_AFFILIATION_MASK,
	COMBATLOG_OBJECT_REACTION_FRIENDLY,
	COMBATLOG_OBJECT_REACTION_NEUTRAL,
	COMBATLOG_OBJECT_REACTION_HOSTILE,
	COMBATLOG_OBJECT_REACTION_MASK,
	COMBATLOG_OBJECT_CONTROL_PLAYER,
	COMBATLOG_OBJECT_CONTROL_NPC,
	COMBATLOG_OBJECT_CONTROL_MASK,
	COMBATLOG_OBJECT_TYPE_PET)
isRaid = bit.bor(
	COMBATLOG_OBJECT_AFFILIATION_RAID,
	COMBATLOG_OBJECT_REACTION_HOSTILE,
	COMBATLOG_OBJECT_REACTION_MASK,
	COMBATLOG_OBJECT_CONTROL_PLAYER,
	COMBATLOG_OBJECT_CONTROL_NPC,
	COMBATLOG_OBJECT_CONTROL_MASK,
	COMBATLOG_OBJECT_TYPE_PLAYER,
	COMBATLOG_OBJECT_TYPE_NPC,
	COMBATLOG_OBJECT_TYPE_PET,
	COMBATLOG_OBJECT_TYPE_GUARDIAN,
	COMBATLOG_OBJECT_TYPE_OBJECT,
	COMBATLOG_OBJECT_TYPE_MASK)
isParty = bit.bor(
	COMBATLOG_OBJECT_AFFILIATION_PARTY,
	COMBATLOG_OBJECT_REACTION_FRIENDLY,
	COMBATLOG_OBJECT_REACTION_HOSTILE,
	COMBATLOG_OBJECT_REACTION_MASK,
	COMBATLOG_OBJECT_CONTROL_PLAYER,
	COMBATLOG_OBJECT_CONTROL_NPC,
	COMBATLOG_OBJECT_CONTROL_MASK,
	COMBATLOG_OBJECT_TYPE_PLAYER,
	COMBATLOG_OBJECT_TYPE_NPC,
	COMBATLOG_OBJECT_TYPE_PET,
	COMBATLOG_OBJECT_TYPE_GUARDIAN,
	COMBATLOG_OBJECT_TYPE_OBJECT,
	COMBATLOG_OBJECT_TYPE_MASK)
isTarget = bit.bor(
	--COMBATLOG_OBJECT_AFFILIATION_MINE,
	--COMBATLOG_OBJECT_AFFILIATION_PARTY,
	--COMBATLOG_OBJECT_AFFILIATION_RAID,
	--COMBATLOG_OBJECT_AFFILIATION_OUTSIDER,
	--COMBATLOG_OBJECT_AFFILIATION_MASK,
	--COMBATLOG_OBJECT_REACTION_HOSTILE,
	--COMBATLOG_OBJECT_REACTION_MASK,
	--COMBATLOG_OBJECT_CONTROL_PLAYER,
	--COMBATLOG_OBJECT_CONTROL_NPC,
	--COMBATLOG_OBJECT_CONTROL_MASK,
	--COMBATLOG_OBJECT_TYPE_PLAYER,
	--COMBATLOG_OBJECT_TYPE_NPC,
	--COMBATLOG_OBJECT_TYPE_PET,
	--COMBATLOG_OBJECT_TYPE_GUARDIAN,
	--COMBATLOG_OBJECT_TYPE_OBJECT,
	--COMBATLOG_OBJECT_TYPE_MASK,
	COMBATLOG_OBJECT_TARGET)
--[[isTargetofTarget = bit.bor(
	)]]--
isFocus = bit.bor(
	COMBATLOG_OBJECT_AFFILIATION_MINE,
	COMBATLOG_OBJECT_AFFILIATION_PARTY,
	COMBATLOG_OBJECT_AFFILIATION_RAID,
	COMBATLOG_OBJECT_AFFILIATION_OUTSIDER,
	--COMBATLOG_OBJECT_AFFILIATION_MASK,
	COMBATLOG_OBJECT_REACTION_HOSTILE,
	--COMBATLOG_OBJECT_REACTION_MASK,
	COMBATLOG_OBJECT_CONTROL_PLAYER,
	COMBATLOG_OBJECT_CONTROL_NPC,
	--COMBATLOG_OBJECT_CONTROL_MASK,
	COMBATLOG_OBJECT_TYPE_PLAYER,
	COMBATLOG_OBJECT_TYPE_NPC,
	COMBATLOG_OBJECT_TYPE_PET,
	COMBATLOG_OBJECT_TYPE_GUARDIAN,
	COMBATLOG_OBJECT_TYPE_OBJECT,
	--COMBATLOG_OBJECT_TYPE_MASK,
	COMBATLOG_OBJECT_FOCUS)
isOther = bit.bor(
	COMBATLOG_OBJECT_AFFILIATION_OUTSIDER,
	COMBATLOG_OBJECT_REACTION_FRIENDLY,
	COMBATLOG_OBJECT_REACTION_NEUTRAL,
	COMBATLOG_OBJECT_REACTION_HOSTILE,
	COMBATLOG_OBJECT_REACTION_MASK,
	COMBATLOG_OBJECT_CONTROL_PLAYER,
	COMBATLOG_OBJECT_CONTROL_NPC,
	COMBATLOG_OBJECT_CONTROL_MASK,
	COMBATLOG_OBJECT_TYPE_PLAYER,
	COMBATLOG_OBJECT_TYPE_NPC,
	COMBATLOG_OBJECT_TYPE_PET,
	COMBATLOG_OBJECT_TYPE_GUARDIAN,
	COMBATLOG_OBJECT_TYPE_OBJECT,
	COMBATLOG_OBJECT_TYPE_MASK)



-- “Copyright 2008 Copystring"